#!/usr/bin/perl -w
# ncnet.pl
# David Rowe 18/7/06
#
# Modifies netlist to remove any nets with "nc" (No connect) in them

my $numArgs = $#ARGV + 1;
if ($numArgs != 2) {
    print "usage: ./ncnet.pl InputNetlistFile OutputNetlistFile\n";
    exit;
}
my $infile = shift;
my $outfile = shift;
open IN,"$infile" or die "Can't open input file $_\n";
open OUT,">$outfile" or die "Can't open output file $_\n";

while (<IN>) {
    if (!/nc(.*)\-1/) {   # remove all dummy nc nets
	print OUT $_;
    }
}

close IN;
close OUT;
