#!/usr/bin/perl -w
# num_refdes.pl
# David Rowe 7 July 2006
#
# Numbers refdes's of the form refdes=X? (where X is C,R etc)
#
# Released under the GNU GENERAL PUBLIC LICENSE Version 2

sub build_refdes($);
sub num_refdes($$);

# list schematic files to scan

build_refdes("4fx.sch");

print "Largest refdes before numbering\n";
foreach $key (keys %refdes) {
    print "$key: $refdes{$key}\n";   
}

# list schematic files to update refdes on

num_refdes("4fx.sch","4fx_new.sch");

print "Largest refdes after numbering\n";
foreach $key (keys %refdes) {
    print "$key: $refdes{$key}\n";   
}

# build a hash containing the largest refdes so far

sub build_refdes($) {
    my $file = shift;

    open SCH, $file or die "Cant open file $_\n";

    while ($line = <SCH>) {
	chomp $line;
	if ($line =~ /refdes=([a-zA-Z]+)(\d+)/) {
	    #print "$line $1 $2\n";
	    if (defined $refdes{$1}) {
		if ($2 > $refdes{$1}) {
		    $refdes{$1} = $2;
		}
	    }
	    else {
		$refdes{$1} = $2;
	    }
	}
    }

    close SCH;
}

# replace any ? refdes numbers 

sub num_refdes($$) {
    my $infile = shift;
    my $outfile = shift;

    open IN, $infile or die "Cant open file $_\n";
    open OUT, ">$outfile" or die "Cant open file $_\n";

    while ($line = <IN>) {
	if ($line =~ /refdes=([a-zA-Z]+)(\?)/) {
	    if (defined $refdes{$1}) {
		$num = $refdes{$1} + 1;
	    }
	    else {
		$num = 1;
	    }
	    $refdes{$1} = $num;
	    $line =~ s/\?/$num/;
	    print "$line";
	}
	print OUT $line;
	    
    }

    close IN;
    close OUT;
}
